﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace Chart_Dynamic_Update
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        DispatcherTimer timer;

        Random random;
        public MainPage()
        {
            this.InitializeComponent();
            InitializeComponent();
            random = new Random();
            timer = new DispatcherTimer();
            timer.Interval = TimeSpan.FromMilliseconds(100);
            timer.Tick += Timer_Tick1; ;
            timer.Start();
        }

        private void Timer_Tick1(object sender, object e)
        {
            var dataSource = (this.updateChart.Series[0].DataContext as ViewModel).List;
            dataSource[0].Value = random.Next(50, 100);
            dataSource[1].Value = random.Next(50, 100);
            dataSource[2].Value = random.Next(50, 100);
            dataSource[3].Value = random.Next(50, 100);
            dataSource[4].Value = random.Next(50, 100);
        }
    }

    public class Model : INotifyPropertyChanged
    {
        private int m_count;
        private double m_value;
        public int Count
        {
            get { return m_count; }
            set
            {
                m_count = value;
                OnPropertyChanged("Count");

            }
        }

        public double Value
        {
            get { return m_value; }
            set
            {
                m_value = value;
                OnPropertyChanged("Value");
            }
        }

        //Property changed notification must be implemented for the dynamic update.
        private void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }

    public class ViewModel
    {

        public ViewModel()
        {
            List = new ObservableCollection<Model>();
            Random random = new Random();

            List.Add(new Model() { Count = 1, Value = 80 });
            List.Add(new Model() { Count = 2, Value = 90 });
            List.Add(new Model() { Count = 3, Value = 40 });
            List.Add(new Model() { Count = 4, Value = 20 });
            List.Add(new Model() { Count = 5, Value = 70 });

        }

        public ObservableCollection<Model> List { get; set; }
    }
}
